import { Chess } from "../chessops/src/chess";
import { Move } from "../chessops/src/types";
import { chessgroundDests } from "../chessops/src/compat";
export { chessgroundDests };
export declare type Uci = string;
export declare type San = string;
export declare type Variant = string;
export declare type Fen = string;
export declare class Pos_ {
    pos: Chess;
    constructor();
    get rules(): Variant;
    get variant(): Variant;
    rawLegalUcis(): string[];
    setVariant(variant: Variant): this;
    setFen(fen: Fen): this;
    reportFen(): string;
    sanToMove(san: San): Move | undefined;
    moveToSan(move: Move): string;
    uciToMove(uci: Uci): Move | undefined;
    moveToUci(move: Move): string;
    play(move: Move): this;
    playSan(san: San): this;
    playUci(uci: Uci): this;
    sanToUci(san: San): Uci | undefined;
    uciToSan(uci: Uci): San | undefined;
    toString(): string;
    legalsForUci(uci: Uci): string[];
    allLegalUcis(): string[];
    allLegalSans(): (string | undefined)[];
}
export declare function Pos(): Pos_;
