import _ from "lodash";

import { Pos_, Pos, chessgroundDests, Variant, Fen } from "./chessops";

export { Pos_, Pos, chessgroundDests, Variant, Fen };

import {
  UciEngine,
  UciEngineNode,
  UciEngineBrowser,
  AnalysisInfo,
  SendAnalysisInfo,
  INFINITE,
} from "./uciengine";

export {
  UciEngine,
  UciEngineNode,
  UciEngineBrowser,
  AnalysisInfo,
  SendAnalysisInfo,
  INFINITE,
};

export function engineTest() {
  const sendAnalysisInfo = (info: AnalysisInfo) => {
    // do something with analysis info
  };

  const engine =
    typeof window !== "undefined"
      ? new UciEngineBrowser(
          "./binweb/stockfish.wasm.js",
          sendAnalysisInfo
        ).spawn()
      : new UciEngineNode("./bin/stockfish", sendAnalysisInfo).spawn();

  engine.go({
    depth: INFINITE,
    multipv: 2,
    bestmoveCallback: (info) =>
      console.log(
        JSON.stringify(
          {
            highest: info.highestCompletedDepth,
            last: _.last(info.depthItems),
          },
          null,
          2
        )
      ),
  });

  setTimeout((_) => {
    engine.stop();
  }, 5000);

  setTimeout((_) => {
    engine.kill();
  }, 10000);
}
